//	yf Net list
//		2005.09.29 - 2005.10.08 Yoshiaki.Ueda
#include "wx/wx.h"
#include "yfNetList.h"
//#include "yfNetListReader.h"	//??
#include <wx/tokenzr.h>
#include <algorithm>

////	Net list ////

	//Initialize
unsigned yfNetList::Net::m_counter = 0;		//for debug

yfNetList::Net::Node::Node()
	: m_same(false)
{
}

yfNetList::Net::Net()
	: m_beginLine(0), m_nextLine(0), m_pickup(false)
{
	m_counter++;
}

	//Sort
bool yfNetList::Net::operator<(const Net& other) const
{
	return m_name.Cmp(other.m_name)<0;
}

bool yfNetList::Net::Node::operator<(const Node& other) const
{
	return m_name.Cmp(other.m_name)<0;
}

bool yfNetList::Sort()
{
	m_list.sort();
	List::iterator net;
	for(net=m_list.begin(); net!=m_list.end(); net++){
		net->m_nodeList.sort();
	}
	return true;
}

	//Find
bool yfNetList::Net::Node::operator==(const Node& other) const
{
	return m_name==other.m_name;
}

bool yfNetList::Net::Node::operator!=(const Node& other) const
{
	return ! operator==(other);
}

bool yfNetList::Net::operator==(const Net& other) const
{
	if( m_nodeList.size()!=other.m_nodeList.size() ) return false;
	NodeList::const_iterator node;
	NodeList::const_iterator otherNode;
	for(node=m_nodeList.begin(), otherNode=other.m_nodeList.begin();
			node!=m_nodeList.end(); node++, otherNode++){
		if(*node!=*otherNode) return false;
	}
	return true;
}

	//Pickup
unsigned yfNetList::Net::IsLike(Net* other, unsigned& maxNode)
{
	if( m_nodeList.size()>other->m_nodeList.size() ){
		maxNode = m_nodeList.size();
	}else{
		maxNode = other->m_nodeList.size();
	}
	unsigned sameNode = 0;
	NodeList::iterator node;
	NodeList::iterator otherNode;
	for(node=m_nodeList.begin(), otherNode=other->m_nodeList.begin();
			node!=m_nodeList.end() && otherNode!=other->m_nodeList.end(); ){
		if(*node==*otherNode){
			node->m_same = otherNode->m_same = true;
			sameNode++;
			node++;
			otherNode++;
		}else
		if(*node<*otherNode){
			node++;
		}else{
			otherNode++;
		}
	}
	return sameNode;
}

yfNetList::Net* yfNetList::Pickup(Net* other, PICKUP_STATUS& status)
{
	List::iterator net;
	for( net=m_list.begin(); net!=m_list.end(); net++ ){
		if(net->m_pickup) continue;
		unsigned sameNode, maxNode;
		if( (sameNode=net->IsLike(other, maxNode))>0 ){
			if(sameNode==maxNode){
				status = SAME;
			}else{
				status = LIKE;
			}
			net->m_pickup = true;
			return &*net;
		}
	}
	status = DIFFER;
	return NULL;
}

	//Dump and text
void yfNetList::Net::GetText(wxTextCtrl& text) const
{
	text.AppendText( wxString::Format(wxT("[%s]"),(const char*)m_name) );
	NodeList::const_iterator node;
	for(node=m_nodeList.begin(); node!=m_nodeList.end(); node++){
		text.AppendText(wxT(' '));
		if(node->m_same){
			text.SetDefaultStyle(wxTextAttr(*wxBLUE));
			text.AppendText(
				wxString::Format(wxT("(%s)"),(const char*)node->m_name) );
		}else{
			text.SetDefaultStyle(wxTextAttr(*wxRED));
			text.AppendText(
				wxString::Format(wxT("<%s>"),(const char*)node->m_name) );
		}
		text.SetDefaultStyle(wxTextAttr(*wxBLACK));
	}
}

const wxString yfNetList::Net::GetText() const
{
	wxString text;
	text += wxString::Format(wxT("[%s]"),(const char*)m_name);
	NodeList::const_iterator node;
	for(node=m_nodeList.begin(); node!=m_nodeList.end(); node++){
		if(node->m_same){
			text += wxString::Format(wxT(" (%s)"),(const char*)node->m_name);
		}else{
			text += wxString::Format(wxT(" <%s>"),(const char*)node->m_name);
		}
	}
	return text;
}

/*const wxString yfNetList::Dump() const
{
	wxString text;
	List::const_iterator net;
	for(net=m_list.begin(); net!=m_list.end(); net++){
		text += wxString::Format(wxT("[%s]"),(const char*)net->m_name);
		Net::NodeList::const_iterator node;
		for(node=net->m_nodeList.begin(); node!=net->m_nodeList.end(); node++){
			text += wxString::Format(wxT(" (%s)"),(const char*)node->m_name);
		}
		text += wxT("\n");
	}
	return text;
}
*/

