//	yf Net list reader base
//		2005.10.11 - 2005.10.16 Yoshaiki.Ueda
#ifndef yf_NET_LIST_READER_BASE_H
#define yf_NET_LIST_READER_BASE_H
#include "yfNetList.h"
#include <wx/tokenzr.h>

//	Tokenizer	//=============================================================
class yfNetListTokenizer
{
public:
	yfNetListTokenizer();
	void SetKeywords(const wxString& keywords =wxT(""));
	void SetString(const wxString& to_tokenize);
	bool HasMoreTokens() const;
	wxString GetNextToken();
protected:
	wxStringTokenizer m_tokenizer;
	wxString m_keywords;
	wxString m_currentToken;
	unsigned m_currentPosition;
};

//	Net list Reader	//=========================================================
class yfNetListReader : public wxObject
{
public:
	yfNetListReader();
	virtual ~yfNetListReader();
	bool Read(const wxString& fileName, yfNetList& netList);
protected:
	unsigned			m_currentLine;
	yfNetListTokenizer	m_tokenizer;
	wxString			m_lastToken;
	yfNetList*			m_netList;
	yfNetList::Net*		m_currentNet;
	virtual void Init(){ };
	virtual void ParseLine(const wxString& source);
	virtual void BeginOfNet(const wxString& name);
	virtual void EndOfNet();
	virtual void OnNode(const wxString& name);
	virtual void OnToken(const wxString& name){ };
	virtual void OnTermLine(){ };
};

#endif//yf_NET_LIST_READER_BASE_H
