//  yf Net list writer base
//      2005.10.16 - 2005.10.16 Yoshaiki.Ueda
#ifndef yf_NET_LIST_WRITER_BASE_H
#define yf_NET_LIST_WRITER_BASE_H
#include "yfNetList.h"
#include <wx/wfstream.h>
#include <wx/txtstrm.h>

//  Net list writer //=========================================================
class yfNetListWriter : public wxObject
{
public:
	yfNetListWriter();
	virtual ~yfNetListWriter();
    bool Write(const wxString& fileName, yfNetList& netList);
protected:
	class wxTextOutputStream* m_out;
	virtual void BeginOfList(){ };
	virtual void BeginOfNet(const wxString& name){ };
	virtual void OnNode(const wxString& name){ };
	virtual void EndOfNet(){ };
	virtual void EndOfList(){ };
};

//	BSch Writer	//=============================================================
class yfNetBschWriter : public yfNetListWriter
{
	DECLARE_DYNAMIC_CLASS(yfNetBschWriter)
protected:
	unsigned m_nodeCount;
	static const unsigned NODE_OF_LINE;
	void BeginOfList();
	void BeginOfNet(const wxString& name);
	void OnNode(const wxString& name);
	void EndOfNet();
	void EndOfList();
};

//	PADS Writer	//=============================================================
class yfNetPadsWriter : public yfNetListWriter
{
	DECLARE_DYNAMIC_CLASS(yfNetPadsWriter)
protected:
	unsigned m_nodeCount;
	static const unsigned NODE_OF_LINE;
	void BeginOfList();
	void BeginOfNet(const wxString& name);
	void OnNode(const wxString& name);
	void EndOfNet();
	void EndOfList();
};

//	Zuken ECF Writer	//=====================================================
class yfNetECFWriter : public yfNetListWriter
{
	DECLARE_DYNAMIC_CLASS(yfNetECFWriter)
protected:
	unsigned m_nodeCount;
	static const unsigned NODE_OF_LINE;
	void BeginOfList();
	void BeginOfNet(const wxString& name);
	void OnNode(const wxString& name);
	void EndOfNet();
	void EndOfList();
};

//	Protel Writer	//=============================================================
class yfNetProtelWriter : public yfNetListWriter
{
	DECLARE_DYNAMIC_CLASS(yfNetProtelWriter)
protected:
	
	
	void BeginOfList();
	void BeginOfNet(const wxString& name);
	void OnNode(const wxString& name);
	void EndOfNet();
	void EndOfList();
};



#endif//yf_NET_LIST_WRITER_BASE_H
